/* SPDX-License-Identifier: GPL-2.0 */
/*
 * Copyright (C) 2018 MIPS Tech, LLC
 * Author: Matt Redfearn <matt.redfearn@loongarch.com>
 */

#ifndef __LOONGARCH_ASM_ISA_REV_H__
#define __LOONGARCH_ASM_ISA_REV_H__

/*
 * The ISA revision level. This is 0 for LOONGARCH I to V and N for
 * LOONGARCH{32,64}rN.
 */

/* If the compiler has defined __loongarch_isa_rev, believe it. */
#ifdef __loongarch_isa_rev
#define LOONGARCH_ISA_REV __loongarch_isa_rev
#else
/* The compiler hasn't defined the isa rev so assume it's LOONGARCH I - V (0) */
#define LOONGARCH_ISA_REV 0
#endif


#endif /* __LOONGARCH_ASM_ISA_REV_H__ */
