/* SPDX-License-Identifier: GPL-2.0 */
/*
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 1999, 2000, 2003 Ralf Baechle
 * Copyright (C) 1999, 2000 Silicon Graphics, Inc.
 * Copyright (C) 2020 Loongson Technology Co., Ltd.
 */
#ifndef _ASM_SIM_H
#define _ASM_SIM_H


#include <asm/asm-offsets.h>

#define __str2(x) #x
#define __str(x) __str2(x)

#ifdef CONFIG_64BIT

#define save_static_function(symbol)					\
__asm__(								\
	".text\n\t"							\
	".globl\t__" #symbol "\n\t"					\
	".align\t2\n\t"							\
	".type\t__" #symbol ", @function\n\t"				\
	"__"#symbol":\n\t"						\
	"st.d\t$s0,$sp,"__str(PT_R23)"\t\t\t# save_static_function\n\t"	\
	"st.d\t$s1,$sp,"__str(PT_R24)"\n\t"				\
	"st.d\t$s2,$sp,"__str(PT_R25)"\n\t"				\
	"st.d\t$s3,$sp,"__str(PT_R26)"\n\t"				\
	"st.d\t$s4,$sp,"__str(PT_R27)"\n\t"				\
	"st.d\t$s5,$sp,"__str(PT_R28)"\n\t"				\
	"st.d\t$s6,$sp,"__str(PT_R29)"\n\t"				\
	"st.d\t$s7,$sp,"__str(PT_R30)"\n\t"				\
	"st.d\t$s8,$sp,"__str(PT_R31)"\n\t"				\
	"b\t" #symbol "\n\t"						\
	".size\t__" #symbol",. - __" #symbol)

#endif /* CONFIG_64BIT */

#endif /* _ASM_SIM_H */
